/*
 * $Header$
 */

/**
 */
int APP_Init (void);

/**
 */
void APP_Uninit (void);

/**
 */
int APP_ParseCommandLine (int argc, char *argv[]);

/**
 * Debugging flag.  Defaults to false but can be set with
 * the "-g" command line option.
 */
extern Boolean APP_isDebug;

/**
 * The number of characters to send.  Defaults to 1 mebabyte,
 * but can be set with the "-c" command line option
 */
extern size_t APP_count;

/**
 * The buffer size for I/O.  Defaults to 1 kilobyte but can
 * be set with the "-i" command line option
 */
extern size_t APP_io_chunk;

/**
 * Fills the buffer ('p[]') and sends the conentents (via '*sendfn')
 * until 'count' characters have been sent.  Stops early if '*sendfn'
 * returns non-zero.
 *
 * Returns 0 on success ('count' characters sent, '*sendfn' always
 * returned 0), non-zero on error (stopped early because '*sendfn'
 * returned non-zero).
 */
int
APP_Loop (size_t count, char p[], size_t plen,
          int (*sendfn) (char [], size_t, size_t));

/**
 * If you are going to send the output to a FILE*, just
 * use this function.  It'll create the buffer, call Loop,
 * and free the buffer.
 */
int APP_LoopFile (size_t count, FILE *fp);

/* --- end of file --- */
