/*
 * $Header$
 */

#ifndef IPC_W
  /*
   * Assume Linux.  Linux defines the lower 9 bits of the
   * flag to 'msgget' as permission bits, just like for 
   * files (except that the execute bits are ignored).  So
   * knowing that, we fake IPC_W and IPC_R.
   */
#define IPC_R 0400
#define IPC_W 0200
#endif

/**
 * The key for the message queue between 'qgenerator' and 'qsink'.
 * Should be unique among message queues.
 */
#define MSGQ_KEY 9871928

/**
 * A message in the message queue
 */
struct MSGQ_Message
{
  /*
   * should be 1
   */
  long mtype;

  /*
   * The number of characters in a[].  If it's less than
   * (sizeof a), then this is the last message in the
   * transmission.
   */
  size_t count;

  /*
   */
  Boolean isEnd;

  /*
   * The payload.
   */
  char a[1];
};

/**
 * Returns the number of characters to allocate for your
 * dynamically sized MSGQ_Message if the I/O chunk size
 * is 'chunk'.
 *
 * Assumes chunk > 0.
 */
size_t MSGQ_Size (size_t chunk);

/* --- end of file --- */
