#! /bin/sh

if test $# -lt 2
then
    echo throughput: Two arguments are required on the command line.
    echo They are MB, which is the number of megabytes to transfer in
    echo each test, and CHUNK, which is the number of bytes in a buffer.
    exit 1
fi

#
# The number of megabytes a generator should generate & send.
# Should be at least 2 times the size of memory.
#
MB=$1
CHUNK=$2

echo \;\;\; method mb chunk duration rate hostname date
for METHOD in run-msgq run-file run-unix run-pipe run-pipe-cat-devnull run-devnull
do
    SZ=`expr $MB \* 1024 \* 1024`
    START=`date +%s`
    bin/$METHOD $SZ $CHUNK
    STOP=`date +%s`
    DURATION=`echo $STOP $START - p |dc`
    RATE=`echo 3 k $MB $DURATION / p |dc`
    echo $METHOD $MB $CHUNK $DURATION $RATE `hostname` `date +%Y-%m-%dT%H:%M:%S`
done

# --- end of file ---
