/*
 * $Header$
 */

#include "all.h"

static int S_Accept (char filename[]);

/**
 * The name of the Unix socket we create & listen on.
 */
static char *S_filename = "tmp/unix-socket.tmp";

/*--------------------------------------------------------------------*/

int
main (int argc, char *argv[])
{
  int rc = 0;

  if (APP_Init () == 0) {
    if (APP_ParseCommandLine (argc, argv) == 0) {
      if (S_Accept (S_filename) == 0) {
	if (APP_LoopFile (APP_count, stdout) == 0) {
	  /*
	   * success
	   */
	} else {
	  fprintf (stderr, "%s:%d: failure\n", __FILE__, __LINE__);
	  rc = 5;
	}
      } else {
	fprintf (stderr, "%s:%d: failure\n", __FILE__, __LINE__);
	rc = 5;
      }
    } else {
      fprintf (stderr, "%s:%d: failure\n", __FILE__, __LINE__);
      rc = -45;
    }
    APP_Uninit ();
  } else {
    fprintf (stderr, "%s:%d: failure\n", __FILE__, __LINE__);
    rc = -43;
  }
  return rc == 0 ? EXIT_SUCCESS : EXIT_FAILURE;
}

static int
S_Accept (char filename[])
{
  int rc = 0;
  int fd;
  int s;
  struct sockaddr_un sau;

  assert (filename != NULL);
  s = socket (AF_UNIX, SOCK_STREAM, 0);
  if (s != -1) {
    memset (&sau, 0, sizeof sau);
    /* sau.sun_len = strlen (filename) + 1; */
    sau.sun_family = AF_UNIX;
    strcpy (sau.sun_path, filename);
    if (bind (s, (struct sockaddr *) &sau, sizeof sau) == 0) {
      if (listen (s, 0) == 0) {
	fd = accept (s, NULL, NULL);
	if (fd != -1) {
	  /*
	   * Redirect stdout to go through the new socket, to
	   * the client.
	   */
	  close (1);
	  dup (fd);
	  close (fd);
	} else {
	  fprintf (stderr, "%s:%d: accept: %s\n", __FILE__, __LINE__,
		   strerror (errno));
	}
      } else {
	fprintf (stderr, "%s:%d: listen: %s\n", __FILE__, __LINE__,
		 strerror (errno));
      }
    } else {
      fprintf (stderr, "%s:%d: bind: %s\n", __FILE__, __LINE__,
	       strerror (errno));
    }
    close (s);
  } else {
    fprintf (stderr, "%s:%d: socket: %s\n", __FILE__, __LINE__,
	     strerror (errno));
  }
  return rc;
}

/* --- end of file --- */
